package ABngSystem;

import ABng_Core_System.*;
import ABng_Core_Management.*;

public class Client
{
	public static void main(String arg[])
  	{
		org.omg.CORBA.Object[] oArray;
		org.omg.CORBA.Object oTemp;
		RepGet cTest;
		String[] sArray;
		Badge Temp;
		
		cTest = new RepGet();

		sArray = cTest.listRepositories();

		for( int i = 0 ; i < sArray.length ; i++ )
			System.out.println( "Repository number " + i + " :" + sArray[i] );

		cTest.init( "Location_Type" );

//////////////////////////////////////////////////////////////////////////////////// ANY

		//org.omg.CORBA.Any anyTemp = new IE.Iona.OrbixWeb.CORBA.Any();
		//	
		//wlozenie + wydobycie zmiennej do any:
		//anyTemp.insert_long( long );                       		anyTemp.extract_long();
		//anyTemp.insert_boolean( boolean );				anyTemp.extract_boolean();
		//anyTemp.insert_Object( objref );				anyTemp.extract_Object();
		//anyTemp.insert_string( string );				anyTemp.extract_string();
		//anyTemp.insert_char( char );					anyTemp.extract_char();
		//anyTemp.insert_Object( object , TCKind.tk_sequence );		???
		//anyTemp.insert_Object( null , TCKind.tk_void ); ????? 		???
		//anyTemp.insert_octet( byte );					anyTemp.extract_octet();
		//dla null uzywassz pustego konstruktora do Any i to wystarcza - wtedy Any przechowuje null
		//anyTemp.insert_any( any );					anyTemp.extract_any();
		//anyTemp.insert_short( short );					anyTemp.extract_short();
		//anyTemp.insert_TypeCode( typecode );				anyTemp.extract_TypeCode();
		//
		//wydobycie typu:
		//TypeCode tc = anyTemp.type();
		//if ( anyTemp.containsType( new IE.Ione.OrbixWeb.CORBA.TypeCode( TCKind.tk_string ) ) ) ToZrobCosTam
		//	
		//przypadki specjalne:
		//w przypadkach zmiennych dla ktorych sa ??? (sequence, void,  a w zasadzie to tylko pierwsze lub zadne )
		//powinienes uzyc anyTemp.extract_Object() i potem zrobic cast do wlasciwego typu, pod warunkiem
		//zgodnosci z anyTemp.type()

//////////////////////////////////////////////////////////////////////////////////// TYPE CODES

		//TypeCode test1 = new TypeCode( TCKind.tk_string );
		//TypeCode_Pattern test2 = BuildTypeCodePattern( test1 );
		//Property_Description_Pattern test3 = BuildPropertyDescriptionPattern( "nazwa" , test2 );
		//Property_Description_Pattern[] test4 = new Property_Description_Pattern[ iles_tam ];
		//test4[0] = test3;
		//test4[1] = test3...;
		//Property_Descriptions_Pattern test5 = BuildPropertyDescriptionsPattern( null , test4 );
		//Location_TypePackage.Pattern test5 = BuildLocationTYpePattern( "" , "nazwa" , test5 );
		//RepGet.find( test5 );
		//	
		//Property_Description testa = new Property_Description( "nazwa" , test1 )
		//PropertyDescription[] testb = new Property_Description[ ile trzeba]
		//testb[0] = testa;
		//...
		//RepGet.add( "" , "nawa" , testb );

////////////////////////////////////////////////////////////////////////////////// VIEWS

		//ABng_Core_Management.View_Manager
		//	ABng_Core.View					.my_view()
		//	String						.my_view().view_name()
		//	String						.my_view().type()
		//	boolean						.my_view().wants_duplicates()
		//
		//
		//
		//	RGContainer					.listLocations()
		//	RGContainer					.listLocatables()
		//
		//	Poniewaz listy zawieraja obiekty typu Location i Locatable przed ich uzyciem nalezy robic tak:
		//	_Badge_Holder dupcia = view.deref_locatable( object )
		//	ABng_Location_Description dupcia = view.deref_location( object )
		//
		//	String						.addLocation( ABng_Core_Managementi.View_Manager, ABng_Location_Description (jako CORBA.Object) )
		//	String						.removeLocation (jak wyzej )
		//	String						.addLocatable( ABng_Core_Management.View_Manager, Badge_Holder (jako CORBA.Object ))
		//
////////////////////////////////////////////////////////////////////////////////// LOCATION TYPE

		//Domain_Repository.Location_Type
		//	int						.item_id()
		//	String						.name()
		//	Domain_Repository.Property_Description[]	.property_description_list()
		//							String			.name
		//							org.omg.CORBA.TypeCode	.type
		
		//Domain_Repository.Location_Description
		//	int						.item_id()
		//	String						.type_name()
		//	Domain_Repository.Property[]			.property_list()
		//							String			.name
		//							org.omg.CORBA.Any    	.value

//////////////////////////////////////////////////////////////////////////////// ABNG LOCATION DESCRIPTION

		//ABng_Core_System.ABng_Location_Description
		//	int						.item_id()
		//	Domain_Repository.Location_Description		.loc_descr()
		//	ABng_Core_System.Sensor[]			.sensor_list()
		//
		// MOJE FUNKCJE: w klasie RepGet
		//
		//	RGContainer					.ABLDlist()		lista sensorow
		//	String (error text)				.ABLDadd( Object , Object)	
		//	dodaje sensor do ABngLocationDescription - pierwszy paramater do ABNGLD a drugi to sensor do dodania - oczywiscie oba moga byc corba objectem.
		//
		//	String (error text)				.ABLDremove( Object, Object)
		//	usuwa sensor z ABngLocationDescription - pierwszy to obiekt ABngLD drugi to sensor do usuniecia.

		
//////////////////////////////////////////////////////////////////////////////// LISTNAMES EXAMPLE

		RGContainer RG = cTest.listRG();

		if( RG.IsError() == false )
		{
			String[] ssArr = RG.GetStrings();
			org.omg.CORBA.Object[] ooArr = RG.GetObjects();

			for (int i = 0 ; i < ssArr.length ; i++ ) {
				System.out.println( ssArr[i] );
			}
		}
		else
			System.out.println( RG.GetErrorText() );


//////////////////////////////////////////////////////////////////////////////// REMOVE EXAMPLE

		// zakladam ze sensTemp zawiera obiekt do skasowania (obiekt uzyskany z list()
		// String error = cTest.remove( Temp );
		// Funkcja zwraca new String("OK") jesli ok lub tekst bledu jesli nie.

//////////////////////////////////////////////////////////////////////////////// ADD EXAMPLE

		// dla Badgy
		// String error = cTest.add( byte[] array, org.omg.CORBA.Object badge_holder );
		// Funkcja zwraca new String("OK") jesli ok lub tekst bledu jesli nie.

		// dla Badge Holderow
		// String error = CTest.add( Object mybadge, Object currentbadge, Object homesensor, null !!!
		// jako ostatni parametr daj null nie wiem jeszcze co i jak z tym gownem.
		// Funkcja zwraca new String("OK") jesli ok lub tekst bledu jesli nie.

///////////////////////////////////////////////////////////////////////////////// UPDATE EXAMPLE

		// WYwolanie prawie identyczne jak dla add() tyle za jako pierwszy parametr nalezy, dodatkowo
		// podac referencje obiektu do updatowania.
		// Funkcja zwraca new String("OK") jesli ok lub tekst bledu jesli nie.

//////////////////////////////////////////////////////////////////////////////// FIND EXAMPLE

		// dla Badge
		// oArray = cTest.find( byte[] array );
		// funkcja zwraca Object[]
		// jesli zachodzi array.length == 0 to wtedy znaczy ze ma szukac dowolnego
		// uwaga! nie wolno dawac null music byc isteniejaca tablica aczkolwiek pusta:
		// byte[] tablica = new byte[0]
 
  	}
}



