/* some patch for sun machines */

#ifndef MY_UTMP_H
#define MY_UTMP_H

#ifdef sunos

#include <utmpx.h>
#define USE_UTMPX
#define _THIS_IS_SUN

struct utmpx *some_utmp_ptr;

typedef struct utmpx my_utmp;

#define UT_LINESIZE (sizeof(some_utmp_ptr->ut_line))
#define UT_HOSTSIZE (sizeof(some_utmp_ptr->ut_host))
#define UT_NAMESIZE (sizeof(some_utmp_ptr->ut_user))

#define get_ut_time(x) ((x)->ut_tv.tv_sec)

#else

#include <utmp.h>

typedef struct utmp my_utmp;
#define get_ut_time(x) ((x)->ut_time)

#endif

my_utmp *my_getutent(void);
my_utmp *my_getutid(const my_utmp *id);
my_utmp *my_getutline(const my_utmp *line);
my_utmp *my_pututline(const my_utmp *utmp);
void my_setutent(void);
void my_endutent(void);
int my_utmpname(const char *file);


#endif /* MY_UTMP_H */
