package jabba;

import com.sun.java.swing.Timer;
import ABng_Server_Manager.TimeServer;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

class Clock {
  TimeServer ts;
  long delta;  // poprawka DODAWANA do liczby sekund
  Timer timeUpdateThread;

  final static long SYNCHRONIZE_EVERY_X_MILLIS = 24L*60L*60L*1000L; // doba
  //  final static long SYNCHRONIZE_EVERY_X_MILLIS = 60L*1000L; // minuta
  //  final static long SYNCHRONIZE_EVERY_X_MILLIS = 15L*1000L; // 15 sekund
  

  public Clock( TimeServer ts ) {
    this.ts = ts;
    if( ts != null ) {
      timeUpdateThread = new Timer( (int)SYNCHRONIZE_EVERY_X_MILLIS, new ActionListener() {
	public void actionPerformed( ActionEvent ev ) {
	  System.err.println( "\n\n\nSynchronizing clock...\n\n\n" );
	  delta = timeServerTimeSeconds() - System.currentTimeMillis()/1000;
	  System.err.println( "Delta = "+delta );
	}
      } );
      timeUpdateThread.setInitialDelay(0);
      timeUpdateThread.start();
    }
    else
      timeUpdateThread = null;
  }

  private long timeServerTimeSeconds() {
    if( ts!=null ) 
      return (long) ts.get_current_time().seconds;
    else 
      return System.currentTimeMillis()/1000;
  }

  public long currentTimeSecs() {
    if( ts!=null ) 
      return System.currentTimeMillis()/1000 +delta;
    else
      return System.currentTimeMillis()/1000;
  }
}
