// Rooms Container for ABng 

package jabba;

import java.util.*;
import java.awt.*;
import com.sun.java.swing.*;

public class Rooms extends JPanel { 

//	private boolean HumanVisible=true;
//	private boolean DeviceVisible=true;
//	private boolean rotated=false;

	private int maxX=0, maxY=0;
	private int origmaxX=0, origmaxY=0;

	private Vector 	rooms;
//	private Vector 	doors;
//	private double zoomFac=1;

	Room currentRoom;

	public Rooms() {
		setLayout(null);
		rooms = new Vector();
//		doors = new Vector();
		setBounds(0,0,500, 500);
		setPreferredSize(new Dimension(500, 500));
	}

	public int sizeR() {
		return rooms.size();
	}

/*	public int sizeD() {
		return doors.size();
	}
*/
	public void addRoom(Room r) {
		if (r.getOrig_x() + r.getSize_x() > maxX)
			maxX = r.getOrig_x() + r.getSize_x();
		if (r.getOrig_y() + r.getSize_y() > maxY)
			maxY = r.getOrig_y() + r.getSize_y();
		origmaxX=maxX;
		origmaxY=maxY;
		setBounds(0,0, maxX, maxY);
		setPreferredSize(new Dimension(maxX, maxY));
		rooms.addElement(r);
		add(r);
		r.setRooms(this);
	}

	public Room getUserLocation (String num) {
		Room r;
		if (num == null) return null;
		for (int i=0; i<sizeR(); i++) {
		  r = getRoomAt(i);
		  if (num.equalsIgnoreCase(r.getNumber())) return r;
		}
		return getRoomAt(20);		//tu trzeba zmienic na korytar
	}

	public Room getEquipmentLocation (String num) {
		Room r;
		if (num == null) return null;
		for (int i=0; i<sizeR(); i++) {
		  r = getRoomAt(i);
		  if (num.equalsIgnoreCase(r.getNumber())) return r;
		}
		return getRoomAt(20);
	}

	public Room getRoomAt(int i) {
		return (Room)rooms.elementAt(i);
	}

 	public void setRoomAt(Room r, int i) {
		rooms.setElementAt(r, i);
	}

	public void removeUsers() {
	Room r;
	for (int i=0; i< sizeR(); i++) {
		r = getRoomAt(i);
		for (int j=0; j<r.getHumSize(); j++)
		   r.remove(r.getHumanAt(j));
		r.allHumans().removeAllElements();	 
		r.setValue();
	}
	}

	public void removeEquipment() {
	Room r;
	for (int i=0; i< sizeR(); i++) {
		r = getRoomAt(i);
		for (int j=0; j<r.getDevSize(); j++)
		   r.remove(r.getDeviceAt(j));
		r.allDevices().removeAllElements();	 
		r.setValue();
	}
	}
/*
	public void addDoor(Door d) {
		doors.addElement(d);
		add(d);
	}

	public Door getDoorAt(int i) {
		return (Door)doors.elementAt(i);
	}
*/
/*	public void setZoom(double i) {
		zoomFac = i;
	}
*/
	public int getMaxX() {
		return maxX;
	}

	public int getMaxY() {
		return maxY;
	}

	public int getiOrigmaxX() {
		return origmaxX;
	}

	public int getOrigmaxY() {
		return origmaxY;
	}


/*	public boolean getRotated() {
		return rotated;
	}
*/
	public void setMaxX(int x) {
		maxX = x;
	}

	public void setMaxY(int y) {
		maxY = y;
	}
/*
	public void setRotated(boolean i) {
		rotated = i;
	}
*/}
