#ifndef _ACORE_TYPES
#define _ACORE_TYPES 1

#include "abng_core_management.hh"
#include "domain_rep_types.h"


#define DEF_TYPE_ABNG(XX)                                                    \
class XX##_Types {                                                           \
public:                                                                      \
  typedef ABng_Core_System::XX Item;                                         \
  typedef ABng_Core_System::XX##_ptr Item_ptr;                               \
  typedef ABng_Core_System::XX##s Items;                       \
  typedef ABng_Core_System::XX::Description Initial_Data;                    \
  typedef ABng_Core_Management::XX##_Rep Repository;                         \
  typedef ABng_Core_Management::XX##_Rep_ptr Repository_ptr;                 \
  typedef ABng_Core_Management::XX##_Rep Repository_Manager;                 \
  typedef ABng_Core_Management::XX##_Rep_ptr Repository_Manager_ptr;         \
                                                                             \
  static ABng_Core_System::XX::Pattern init_pattern();                       \
};                                                                           \
                                                                             \
ostream& operator << (ostream&, ABng_Core_System::XX::Value_Description&);

DEF_TYPE_ABNG(Sensor)
DEF_TYPE_ABNG(ABng_Location_Description)
DEF_TYPE_ABNG(Badge)
DEF_TYPE_ABNG(Badge_Holder)

#endif _ACORE_TYPES
