// -*- Mode: C++; -*-
//
// Hides Orbix 2.2 (<=) bug : TypeCodes marshalled as strings
//

package Domain_Repository;

// import AnyPrinter;

public class OBUG {
  private static void stack() {
    try {
      throw new Exception("");
    }
    catch ( Exception ex) {
      ex.printStackTrace();
    }
  }

  private static boolean translateAny= true;

  public static void turnOff() {
    translateAny= false;
  }

  public static void turnOn() {
    translateAny= true;
  }

  public static org.omg.CORBA.TypeCode read_TypeCodeAsString(
	org.omg.CORBA.portable.InputStream pis) {

    if (translateAny) {
      System.err.print("OBUG: read_TypeCodeAsString");
      String otc= pis.read_string();
      System.err.println(" "+otc);

      org.omg.CORBA.TypeCode tc= 
	IE.Iona.OrbixWeb.OrbixProt.OrbixTypeCode.IT_create( otc);
      return tc;
    }
    else {
      return pis.read_TypeCode();
    }

    //---------------------------
    /*
    if ( otc.equals("s")) {
      return org.omg.CORBA.ORB.init().get_primitive_tc( org.omg.CORBA.TCKind.tk_short);
    } else if ( otc.equals("l")) {
      return org.omg.CORBA.ORB.init().get_primitive_tc( org.omg.CORBA.TCKind.tk_long);
    } else if ( otc.equals("b")) {
      return org.omg.CORBA.ORB.init().get_primitive_tc( org.omg.CORBA.TCKind.tk_boolean);
    } else if ( otc.equals("0")) {
      return org.omg.CORBA.ORB.init().create_string_tc( 0);
    } else if ( otc.equals("n")) {
      return org.omg.CORBA.ORB.init().get_primitive_tc( org.omg.CORBA.TCKind.tk_null);
    } else if ( otc.equals("v")) {
      return org.omg.CORBA.ORB.init().get_primitive_tc( org.omg.CORBA.TCKind.tk_void);
    } else {
      System.err.println("Unmapped Orbix typecode "+otc);
      stack();
      return null;
    } 
    */
  }
  /*
  public static org.omg.CORBA.Any read_AnyAsString(
	       org.omg.CORBA.portable.InputStream pis) {

   
    if ( translateAny) {
      System.err.println("OBUG: read_AnyAsString");
      org.omg.CORBA.Any ret= org.omg.CORBA.ORB.init().create_any();

      ret.type( read_TypeCodeAsString( pis));
      try {
	ret.read_value( pis, ret.type());
      }
      catch ( Exception ex) {
	ex.printStackTrace();
      }
      org.omg.CORBA.portable.OutputStream os= org.omg.CORBA.ORB.init().create_output_stream();
      os.write_any( ret);
      try {
	os.flush();
      }
      catch ( Exception ex) {}
      return os.create_input_stream().read_any();
    }
    else {
      System.err.println("OBUG: read Any");
      return pis.read_any();
    }
  }
  */
  public static void write_TypeCodeAsString(
	org.omg.CORBA.portable.OutputStream pos,
	org.omg.CORBA.TypeCode tc) {

    if (translateAny) {
      System.err.print("OBUG: write_TypeCodeAsString ");
      IE.Iona.OrbixWeb.OrbixProt.OrbixTypeCode otc= 
      new IE.Iona.OrbixWeb.OrbixProt.OrbixTypeCode( tc);
      System.err.println( otc._tc_string);
      pos.write_string( otc._tc_string);
    }
    else {
      pos.write_TypeCode( tc);
    }
    return;
    //-------------------------------
    /*
    switch ( tc.kind().value()) {
    case org.omg.CORBA.TCKind._tk_short:
      pos.write_string("s"); System.err.println("s");
      break;
    case org.omg.CORBA.TCKind._tk_long:
      pos.write_string("l"); System.err.println("l");
      break;
    case org.omg.CORBA.TCKind._tk_boolean:
      pos.write_string("b"); System.err.println("b");
      break;
    case org.omg.CORBA.TCKind._tk_string:
      pos.write_string("0"); System.err.println("0");
      break;
    case org.omg.CORBA.TCKind._tk_null:
      pos.write_string("n"); System.err.println("n");
      break;
    case org.omg.CORBA.TCKind._tk_void:
      pos.write_string("v"); System.err.println("v");
      break;
    default:
      System.err.println("Unmapped OMG typecode "+tc.kind().value());
      stack();
      System.exit( 1);
    }
    */
  }
  /*
  public static void write_AnyAsString(
        org.omg.CORBA.portable.OutputStream pos,
	org.omg.CORBA.Any val) {
  
    org.omg.CORBA.portable.OutputStream os= org.omg.CORBA.ORB.init().create_output_stream();
    os.write_any( val);
    try {
      os.flush();
    }
    catch ( Exception ex) {}
    org.omg.CORBA.Any nval= os.create_input_stream().read_any();

    if ( translateAny) {
      System.err.println("OBUG: write_AnyAsString");
      write_TypeCodeAsString( pos, nval.type());
      nval.write_value( pos);
    }
    else {
      System.err.println("OBUG: write Any");
      pos.write_any( nval);
    }
  }
  */
};






