//
// $Id: ORB_wrapper.java,v 1.2 1998/07/29 13:25:06 mencnar Exp $
//
// $Log: ORB_wrapper.java,v $
// Revision 1.2  1998/07/29 13:25:06  mencnar
// minor bug fixes in Visibroker 3.2 port
//
// Revision 1.1.1.1  1998/07/03 13:04:43  mencnar
//
//

package pl.edu.agh.ics.abngcore;

public class ORB_wrapper {
  public static ORB_wrapper instance= null;

  private ORB_wrapper real_instance= null;

  public ORB_wrapper() {
    instance= this;
  }

  public void init_application( String argv[] ) {
    if (real_instance == null) init_class();
    real_instance.init_application( argv);
  }

  public void connect_object( org.omg.CORBA.Object obj) {
    if (real_instance == null) init_class();
    real_instance.connect_object( obj);    
  }

  public void disconnect_object( org.omg.CORBA.Object obj) {
    if (real_instance == null) init_class();
    real_instance.disconnect_object( obj);    
  }

  public void impl_is_ready( ) {
    if (real_instance == null) init_class();
    real_instance.impl_is_ready( );        
  }

  public void call_static_notify(
	Domain_Repository.Static_Data_Observer obs,
	int item_id, 
	Domain_Repository.Static_Data_ObserverPackage.Static_Data_Object obj,
	Domain_Repository.Change_Type change) {

    if (real_instance == null) init_class();
    real_instance.call_static_notify( obs, item_id, obj, change);        
  }


  private void init_class() {
    try {
      String orb_ver= System.getProperty( "CORBA_JAVA_ORBIX_VER");
      if ( ("30").equals( orb_ver)) {
	real_instance= (ORB_wrapper) (Class.forName("pl.edu.agh.ics.abngcore.ORB_wrapper_orbixweb").newInstance());
	return;
      }
      orb_ver= System.getProperty( "CORBA_JAVA_VBROKER_VER");
      if ( ("32").equals( orb_ver)) {
	real_instance= (ORB_wrapper) (Class.forName("pl.edu.agh.ics.abngcore.ORB_wrapper_vbroker").newInstance());
	return;
      }
      
      System.err.println("CORBA_JAVA_ORBIX_VER and/or CORBA_JAVA_VBROKER_VER properties\n are undefined");
    }
    catch (Exception ex) {
      System.err.println( ex.toString());
      System.exit(1);
    }
  }
}
