#ifndef __AWAY_REP_SERVER_H__
#define __AWAY_REP_SERVER_H__ 1

#include "rep_server.h"
#include "away_rep_i.hh"

class Away_Rep_Server : public Rep_Server {

public:

  Away_Rep_Server(
#ifdef ObjectStore
    const char *db_name_p = "dbName",
#elif FilePersistency
    const char *file_name_p = "Away_Rep.db",
#endif
    const char *current_directory_p = ".") : Rep_Server(
#ifdef ObjectStore
    db_name_p,
#elif FilePersistency
    file_name_p,
#endif
    current_directory_p) {}

  virtual ~Away_Rep_Server() {}

  virtual void create_objects();
  virtual void delete_objects();

protected:
  Away_Rep_I *my_rep_i;
};

#endif // __AWAY_REP_SERVER_H__

//





