#ifndef __LT_REP_CLIENT_H__
#define __LT_REP_CLIENT_H__ 1

#include <stream.h>

#include "domain_rep_management.hh"
#include "domain_rep_types_mgr.h"
#include "bootstrap_n.hh"
#include "rep_client.h"


class LT_Rep_Client : public Rep_Client<Location_Type_Types_Mgr> {

public:

  LT_Rep_Client() : Rep_Client<Location_Type_Types_Mgr>(
                      Bootstrap::SRV_Location_Type_Repository,
                      Bootstrap::SRV_Location_Type_Repository_Manager) { }

  virtual ~LT_Rep_Client() {}

  virtual Domain_Repository::Location_Type::Description
        init_data(char* data);
  
};

#endif __LT_REP_CLIENT_H__





