
#ifndef tevent_data_observed_e_hh
#define tevent_data_observed_e_hh

#define CALL_SPEC 
#include <CORBA.h>

#include <string.h>


#include <domain_rep.hh>


#include <abng_core.hh>

class TEvent_Data_Observer;

#ifndef TEvent_Data_ObserverPtr
#define TEvent_Data_ObserverPtr
typedef TEvent_Data_Observer* TEvent_Data_Observer_ptr;
typedef TEvent_Data_Observer* TEvent_Data_ObserverRef;
#endif

#ifndef TEvent_Data_Observer_ptrTypedefs
#define TEvent_Data_Observer_ptrTypedefs
typedef const TEvent_Data_Observer* TEvent_Data_Observer_cptr;
#endif


#ifndef TEvent_Data_ObserverForwH
#define TEvent_Data_ObserverForwH
CORBA::ObjectRef CALL_SPEC TEvent_Data_Observer_getBase (void *);
void CALL_SPEC TEvent_Data_Observer_release (TEvent_Data_Observer *, CORBA::Environment &IT_env);
void CALL_SPEC TEvent_Data_Observer_release (TEvent_Data_Observer_ptr);
TEvent_Data_Observer* CALL_SPEC TEvent_Data_Observer_duplicate (TEvent_Data_Observer_ptr, CORBA::Environment &IT_env);
TEvent_Data_Observer* CALL_SPEC TEvent_Data_Observer_duplicate (TEvent_Data_Observer_ptr );
TEvent_Data_Observer_ptr CALL_SPEC TEvent_Data_Observer_nil (CORBA::Environment &IT_env);
TEvent_Data_Observer_ptr CALL_SPEC TEvent_Data_Observer_nil ();
#endif
#ifndef TEvent_Data_ObserverMgrH
#define TEvent_Data_ObserverMgrH

class TEvent_Data_Observer_var;

class TEvent_Data_Observer_SeqElem;

#ifndef TEvent_Data_Observer_ptrTypedefs
#define TEvent_Data_Observer_ptrTypedefs
typedef const TEvent_Data_Observer* TEvent_Data_Observer_cptr;
#endif

class TEvent_Data_Observer_mgr : public CORBA::_mgr
{
    public:

    TEvent_Data_Observer_mgr ();
    TEvent_Data_Observer_mgr (const TEvent_Data_Observer_mgr &IT_s);
    TEvent_Data_Observer_mgr (TEvent_Data_Observer_var IT_s);
    TEvent_Data_Observer_mgr (const TEvent_Data_Observer_SeqElem &IT_s);
    TEvent_Data_Observer_mgr &operator= (TEvent_Data_Observer_ptr IT_p);
    TEvent_Data_Observer_mgr &operator= (const TEvent_Data_Observer_mgr &IT_s);
    TEvent_Data_Observer_mgr &operator= (TEvent_Data_Observer_var IT_s);
    TEvent_Data_Observer_mgr &operator= (const TEvent_Data_Observer_SeqElem &IT_s);
    ~TEvent_Data_Observer_mgr ();
    TEvent_Data_Observer_ptr operator-> () const;
    operator ! () const;
    operator TEvent_Data_Observer_ptr& () ;
    operator const TEvent_Data_Observer_ptr& () const;
    TEvent_Data_Observer_ptr _ptr;

    operator CORBA::Object_ptr () const;
    TEvent_Data_Observer_ptr in () const;
    TEvent_Data_Observer_ptr& inOut ();
    TEvent_Data_Observer_ptr& out ();
    TEvent_Data_Observer_ptr ret () const;
};

#endif

#ifndef TEvent_Data_ObserverSeqElemH
#define TEvent_Data_ObserverSeqElemH

class TEvent_Data_Observer_SeqElem : public CORBA::_SeqElem
{
    public:

    TEvent_Data_Observer_SeqElem (TEvent_Data_Observer_ptr* IT_p, unsigned char rel);
    TEvent_Data_Observer_SeqElem &operator= (TEvent_Data_Observer_ptr IT_p);
    TEvent_Data_Observer_SeqElem &operator= (const TEvent_Data_Observer_SeqElem &IT_s);
    TEvent_Data_Observer_SeqElem &operator= (const TEvent_Data_Observer_mgr &IT_s);
    TEvent_Data_Observer_SeqElem &operator= (TEvent_Data_Observer_var IT_s);
    operator ! () const;
    operator const TEvent_Data_Observer_ptr& () const;
    operator CORBA::Object_ptr () const;
    TEvent_Data_Observer_ptr in () const;
    TEvent_Data_Observer_ptr& inOut ();
    TEvent_Data_Observer_ptr& out ();
    TEvent_Data_Observer_ptr ret () const;
    TEvent_Data_Observer_ptr operator->() const;

    protected:
    TEvent_Data_Observer_ptr *_ptr;
    unsigned char _release;
};

#endif

#define TEvent_Data_Observer_IMPL "TEvent_Data_Observer"


#ifndef _TEvent_Data_Observed_E_defined
#define _TEvent_Data_Observed_E_defined
class TEvent_Data_Observed_E_dispatch : public virtual CORBA::PPTR {
public:

      TEvent_Data_Observed_E_dispatch (void *IT_p, CORBA::Object* IT_o, const char *IT_m, 
        CORBA::LoaderClass *IT_l, char *IT_i, void* IT_im)
       : PPTR (IT_p,IT_o,IT_m,IT_l,IT_i,IT_im) {}


   TEvent_Data_Observed_E_dispatch (char *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : PPTR (IT_OR,IT_p,IT_o) {}


   TEvent_Data_Observed_E_dispatch () {}

   TEvent_Data_Observed_E_dispatch (ObjectReferenceImpl *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : PPTR (IT_OR,IT_p,IT_o) {}


   TEvent_Data_Observed_E_dispatch (void *IT_p, CORBA::Object *IT_o, const char *IT_m, 
        char *IT_i, CORBA::Object* IT_ob, void* IT_im)
       : PPTR (IT_p,IT_o,IT_m,IT_i,IT_ob,IT_im) {}


   virtual unsigned char dispatch (CORBA::Request &IT_r, 
        unsigned char IT_isTarget, void* IT_pp=NULL);


};

class TEvent_Data_Observed_E;

#ifndef TEvent_Data_Observed_EPtr
#define TEvent_Data_Observed_EPtr
typedef TEvent_Data_Observed_E* TEvent_Data_Observed_E_ptr;
typedef TEvent_Data_Observed_E* TEvent_Data_Observed_ERef;
#endif

#ifndef TEvent_Data_Observed_E_ptrTypedefs
#define TEvent_Data_Observed_E_ptrTypedefs
typedef const TEvent_Data_Observed_E* TEvent_Data_Observed_E_cptr;
#endif


#ifndef TEvent_Data_Observed_EForwH
#define TEvent_Data_Observed_EForwH
CORBA::ObjectRef CALL_SPEC TEvent_Data_Observed_E_getBase (void *);
void CALL_SPEC TEvent_Data_Observed_E_release (TEvent_Data_Observed_E *, CORBA::Environment &IT_env);
void CALL_SPEC TEvent_Data_Observed_E_release (TEvent_Data_Observed_E_ptr);
TEvent_Data_Observed_E* CALL_SPEC TEvent_Data_Observed_E_duplicate (TEvent_Data_Observed_E_ptr, CORBA::Environment &IT_env);
TEvent_Data_Observed_E* CALL_SPEC TEvent_Data_Observed_E_duplicate (TEvent_Data_Observed_E_ptr );
TEvent_Data_Observed_E_ptr CALL_SPEC TEvent_Data_Observed_E_nil (CORBA::Environment &IT_env);
TEvent_Data_Observed_E_ptr CALL_SPEC TEvent_Data_Observed_E_nil ();
#endif
#ifndef TEvent_Data_Observed_EMgrH
#define TEvent_Data_Observed_EMgrH

class TEvent_Data_Observed_E_var;

class TEvent_Data_Observed_E_SeqElem;

#ifndef TEvent_Data_Observed_E_ptrTypedefs
#define TEvent_Data_Observed_E_ptrTypedefs
typedef const TEvent_Data_Observed_E* TEvent_Data_Observed_E_cptr;
#endif

class TEvent_Data_Observed_E_mgr : public CORBA::_mgr
{
    public:

    TEvent_Data_Observed_E_mgr ();
    TEvent_Data_Observed_E_mgr (const TEvent_Data_Observed_E_mgr &IT_s);
    TEvent_Data_Observed_E_mgr (TEvent_Data_Observed_E_var IT_s);
    TEvent_Data_Observed_E_mgr (const TEvent_Data_Observed_E_SeqElem &IT_s);
    TEvent_Data_Observed_E_mgr &operator= (TEvent_Data_Observed_E_ptr IT_p);
    TEvent_Data_Observed_E_mgr &operator= (const TEvent_Data_Observed_E_mgr &IT_s);
    TEvent_Data_Observed_E_mgr &operator= (TEvent_Data_Observed_E_var IT_s);
    TEvent_Data_Observed_E_mgr &operator= (const TEvent_Data_Observed_E_SeqElem &IT_s);
    ~TEvent_Data_Observed_E_mgr ();
    TEvent_Data_Observed_E_ptr operator-> () const;
    operator ! () const;
    operator TEvent_Data_Observed_E_ptr& () ;
    operator const TEvent_Data_Observed_E_ptr& () const;
    TEvent_Data_Observed_E_ptr _ptr;

    operator CORBA::Object_ptr () const;
    TEvent_Data_Observed_E_ptr in () const;
    TEvent_Data_Observed_E_ptr& inOut ();
    TEvent_Data_Observed_E_ptr& out ();
    TEvent_Data_Observed_E_ptr ret () const;
};

#endif

#ifndef TEvent_Data_Observed_ESeqElemH
#define TEvent_Data_Observed_ESeqElemH

class TEvent_Data_Observed_E_SeqElem : public CORBA::_SeqElem
{
    public:

    TEvent_Data_Observed_E_SeqElem (TEvent_Data_Observed_E_ptr* IT_p, unsigned char rel);
    TEvent_Data_Observed_E_SeqElem &operator= (TEvent_Data_Observed_E_ptr IT_p);
    TEvent_Data_Observed_E_SeqElem &operator= (const TEvent_Data_Observed_E_SeqElem &IT_s);
    TEvent_Data_Observed_E_SeqElem &operator= (const TEvent_Data_Observed_E_mgr &IT_s);
    TEvent_Data_Observed_E_SeqElem &operator= (TEvent_Data_Observed_E_var IT_s);
    operator ! () const;
    operator const TEvent_Data_Observed_E_ptr& () const;
    operator CORBA::Object_ptr () const;
    TEvent_Data_Observed_E_ptr in () const;
    TEvent_Data_Observed_E_ptr& inOut ();
    TEvent_Data_Observed_E_ptr& out ();
    TEvent_Data_Observed_E_ptr ret () const;
    TEvent_Data_Observed_E_ptr operator->() const;

    protected:
    TEvent_Data_Observed_E_ptr *_ptr;
    unsigned char _release;
};

#endif

#define TEvent_Data_Observed_E_IMPL "TEvent_Data_Observed_E"


class TEvent_Data_Observed_E;

typedef TEvent_Data_Observed_E TEvent_Data_Observed_EProxy;
#define TEvent_Data_Observed_E_IR "TEvent_Data_Observed_E"
#define TEvent_Data_Observed_E_IMPL "TEvent_Data_Observed_E"

#ifndef TEvent_Data_Observed_EPtr
#define TEvent_Data_Observed_EPtr
typedef TEvent_Data_Observed_E* TEvent_Data_Observed_E_ptr;
typedef TEvent_Data_Observed_E* TEvent_Data_Observed_ERef;
#endif

#ifndef TEvent_Data_Observed_E_ptrTypedefs
#define TEvent_Data_Observed_E_ptrTypedefs
typedef const TEvent_Data_Observed_E* TEvent_Data_Observed_E_cptr;
#endif

class TEvent_Data_Observed_E: public virtual CORBA::Object  {
public:
        TEvent_Data_Observed_E (char *IT_OR);
    TEvent_Data_Observed_E (ObjectReferenceImpl *IT_OR);
    TEvent_Data_Observed_E () : CORBA::Object  (1) {}
protected:
    TEvent_Data_Observed_E_ptr __duplicate(
            CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) {
       CORBA::Object::__duplicate (IT_env);
       return this;
    }
public:
    static TEvent_Data_Observed_E_ptr CALL_SPEC _duplicate(
            TEvent_Data_Observed_E_ptr, 
            CORBA::Environment &IT_pEnv=CORBA::IT_chooseDefaultEnv ());
public:
   static TEvent_Data_Observed_E* CALL_SPEC _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
   static TEvent_Data_Observed_E* CALL_SPEC _bind (CORBA::Environment &IT_env);
   static TEvent_Data_Observed_E* CALL_SPEC _bind (const char* IT_markerServer=NULL, const char* host=NULL,
                 CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
    static TEvent_Data_Observed_E* CALL_SPEC _narrow (CORBA::Object* , CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
private:
    static const void* IT_impl;
public:
    static TEvent_Data_Observed_E_ptr CALL_SPEC  _nil (CORBA::Environment &IT_pEnv=CORBA::IT_chooseDefaultEnv ()) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
        return (TEvent_Data_Observed_E_ptr) CORBA::OBJECT_NIL;}

#ifndef TEvent_Data_Observed_E__IDL_SEQUENCE_TEvent_Data_Observer_defined
#define TEvent_Data_Observed_E__IDL_SEQUENCE_TEvent_Data_Observer_defined

class  _IDL_SEQUENCE_TEvent_Data_Observer {
    CORBA::ULong _maximum;
    CORBA::ULong _length;
    TEvent_Data_Observer_ptr* _buffer;
    unsigned char _release;

    public:
    _IDL_SEQUENCE_TEvent_Data_Observer& operator= (const _IDL_SEQUENCE_TEvent_Data_Observer&);
    _IDL_SEQUENCE_TEvent_Data_Observer (const _IDL_SEQUENCE_TEvent_Data_Observer&);

    _IDL_SEQUENCE_TEvent_Data_Observer (CORBA::ULong max);
    _IDL_SEQUENCE_TEvent_Data_Observer (CORBA::ULong max, CORBA::ULong length, TEvent_Data_Observer_ptr* data, CORBA::Boolean release = 0);
    _IDL_SEQUENCE_TEvent_Data_Observer ();

    ~_IDL_SEQUENCE_TEvent_Data_Observer ();

    static TEvent_Data_Observer_ptr* CALL_SPEC allocbuf(CORBA::ULong nelems);
    static void CALL_SPEC freebuf(TEvent_Data_Observer_ptr* data);

    CORBA::ULong maximum() const;
    CORBA::ULong length() const;
    void length (CORBA::ULong len);

    TEvent_Data_Observer_SeqElem operator [] (CORBA::ULong IT_i);

    const TEvent_Data_Observer_SeqElem operator [] (CORBA::ULong IT_i) const;

    void assignbuf (CORBA::ULong max, CORBA::ULong length, TEvent_Data_Observer_ptr* data, CORBA::Boolean release = 0);
    void encodeOp (CORBA::Request &IT_r) const;
    void decodeOp (CORBA::Request &IT_r);
    void decodeInOutOp (CORBA::Request &IT_r);
};

#ifndef TEvent_Data_Observed_E__IDL_SEQUENCE_TEvent_Data_ObserverVarH
#define TEvent_Data_Observed_E__IDL_SEQUENCE_TEvent_Data_ObserverVarH

#ifndef TEvent_Data_Observed_E__IDL_SEQUENCE_TEvent_Data_Observer_ptrTypedefsNC
#define TEvent_Data_Observed_E__IDL_SEQUENCE_TEvent_Data_Observer_ptrTypedefsNC
typedef _IDL_SEQUENCE_TEvent_Data_Observer* _IDL_SEQUENCE_TEvent_Data_Observer_ptr;
#endif

#ifndef TEvent_Data_Observed_E__IDL_SEQUENCE_TEvent_Data_Observer_ptrTypedefs
#define TEvent_Data_Observed_E__IDL_SEQUENCE_TEvent_Data_Observer_ptrTypedefs
typedef const _IDL_SEQUENCE_TEvent_Data_Observer* _IDL_SEQUENCE_TEvent_Data_Observer_cptr;
#endif

class _IDL_SEQUENCE_TEvent_Data_Observer_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const _IDL_SEQUENCE_TEvent_Data_Observer_var &IT_s);

    public:

    _IDL_SEQUENCE_TEvent_Data_Observer_var (const _IDL_SEQUENCE_TEvent_Data_Observer_var &IT_s);
    _IDL_SEQUENCE_TEvent_Data_Observer_var ();
    _IDL_SEQUENCE_TEvent_Data_Observer_var (_IDL_SEQUENCE_TEvent_Data_Observer_ptr IT_p);
    _IDL_SEQUENCE_TEvent_Data_Observer_var &operator= (_IDL_SEQUENCE_TEvent_Data_Observer_ptr IT_p);
    _IDL_SEQUENCE_TEvent_Data_Observer_var &operator= (const _IDL_SEQUENCE_TEvent_Data_Observer_var &IT_s);
    ~_IDL_SEQUENCE_TEvent_Data_Observer_var ();
    _IDL_SEQUENCE_TEvent_Data_Observer_ptr operator-> () const;
    operator ! () const;
    operator _IDL_SEQUENCE_TEvent_Data_Observer_ptr& () ;
    operator const _IDL_SEQUENCE_TEvent_Data_Observer_cptr& () const;
    operator _IDL_SEQUENCE_TEvent_Data_Observer& () const;

    const _IDL_SEQUENCE_TEvent_Data_Observer in () const;
    _IDL_SEQUENCE_TEvent_Data_Observer& inOut ();
    _IDL_SEQUENCE_TEvent_Data_Observer*& out ();
    _IDL_SEQUENCE_TEvent_Data_Observer* ret () const;
    const TEvent_Data_Observer_SeqElem operator[] (CORBA::ULong index) const;

    TEvent_Data_Observer_SeqElem operator[] (CORBA::ULong index);

    protected:
    _IDL_SEQUENCE_TEvent_Data_Observer_ptr* _indPtr;
    _IDL_SEQUENCE_TEvent_Data_Observer_ptr& _ptr;
    private:
    static _IDL_SEQUENCE_TEvent_Data_Observer_ptr* _newPtr ();
    _IDL_SEQUENCE_TEvent_Data_Observer_var &operator= (const CORBA::_var &IT_s);
    _IDL_SEQUENCE_TEvent_Data_Observer_var (const CORBA::_var &IT_s);
};

#endif


#endif

typedef _IDL_SEQUENCE_TEvent_Data_Observer TEvent_Data_Observers;
typedef const _IDL_SEQUENCE_TEvent_Data_Observer TEvent_Data_Observers_IT_const;

typedef _IDL_SEQUENCE_TEvent_Data_Observer_var TEvent_Data_Observers_var;

    virtual TEvent_Data_Observers* tevent_data_observer_list (CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException);
        virtual void attach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException);
        virtual void detach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException, Domain_Repository::Unknown_Observer);
};

#ifndef TEvent_Data_Observed_EVarH
#define TEvent_Data_Observed_EVarH

#ifndef TEvent_Data_Observed_E_ptrTypedefs
#define TEvent_Data_Observed_E_ptrTypedefs
typedef const TEvent_Data_Observed_E* TEvent_Data_Observed_E_cptr;
#endif

class TEvent_Data_Observed_E_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const TEvent_Data_Observed_E_var &IT_s);
    unsigned char copyHelper (const TEvent_Data_Observed_E_mgr &IT_s);
    unsigned char copyHelper (const TEvent_Data_Observed_E_SeqElem &IT_s);

    public:

    TEvent_Data_Observed_E_var (const TEvent_Data_Observed_E_var &IT_s);
    TEvent_Data_Observed_E_var (const TEvent_Data_Observed_E_mgr &IT_s);
    TEvent_Data_Observed_E_var (const TEvent_Data_Observed_E_SeqElem &IT_s);
    TEvent_Data_Observed_E_var ();
    TEvent_Data_Observed_E_var (TEvent_Data_Observed_E_ptr IT_p);
    TEvent_Data_Observed_E_var &operator= (TEvent_Data_Observed_E_ptr IT_p);
    TEvent_Data_Observed_E_var &operator= (const TEvent_Data_Observed_E_var &IT_s);
    TEvent_Data_Observed_E_var &operator= (const TEvent_Data_Observed_E_mgr &IT_s);
    TEvent_Data_Observed_E_var &operator= (const TEvent_Data_Observed_E_SeqElem &IT_s);
    ~TEvent_Data_Observed_E_var ();
    TEvent_Data_Observed_E_ptr operator-> () const;
    operator ! () const;
    operator TEvent_Data_Observed_E_ptr& () ;
    operator const TEvent_Data_Observed_E_cptr& () const;

    operator CORBA::Object_ptr () const;
    TEvent_Data_Observed_E_ptr in () const;
    TEvent_Data_Observed_E_ptr& inOut ();
    TEvent_Data_Observed_E_ptr& out ();
    TEvent_Data_Observed_E_ptr ret () const;
    protected:
    TEvent_Data_Observed_E_ptr* _indPtr;
    TEvent_Data_Observed_E_ptr& _ptr;
    private:
    static TEvent_Data_Observed_E_ptr* _newPtr ();
    TEvent_Data_Observed_E_var &operator= (const CORBA::_var &IT_s);
    TEvent_Data_Observed_E_var (const CORBA::_var &IT_s);
};

#endif



#define TIE_TEvent_Data_Observed_E(X) TEvent_Data_Observed_E##X

#define DEF_TIE_TEvent_Data_Observed_E(X) \
	class TEvent_Data_Observed_E##X : public virtual TEvent_Data_Observed_E {		\
	  X* m_obj;						\
	public:							\
								\
								\
	   TEvent_Data_Observed_E##X  (X *objp, const char* m="", CORBA::LoaderClass *l=0)\
		: TEvent_Data_Observed_E(), m_obj(objp) {	\
		m_pptr = new TEvent_Data_Observed_E_dispatch		\
			(( TEvent_Data_Observed_E*)this,(CORBA::Object*)this,m,l,TEvent_Data_Observed_E_IR,m_obj);	\
	   }								\
	   TEvent_Data_Observed_E##X  (CORBA::Object *IT_p, const char* IT_m="", void *IT_q=0)\
		: TEvent_Data_Observed_E() {	\
		m_pptr = new TEvent_Data_Observed_E_dispatch		\
			(( TEvent_Data_Observed_E*)this,(CORBA::Object*)this,IT_m,TEvent_Data_Observed_E_IR,IT_p,IT_q);	\
		m_obj = (X*)(m_pptr->getImplObj ());			\
	   }								\
								\
	   virtual ~TEvent_Data_Observed_E##X  () {				\
		if (_okToDeleteImpl ()) delete m_obj; }					\
	   virtual void* _deref () {					\
		return m_obj; }					\
								\
virtual TEvent_Data_Observed_E::TEvent_Data_Observers* tevent_data_observer_list (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->tevent_data_observer_list(IT_env); \
}\
	\
virtual void attach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException){\
m_obj->attach_tevent_data_observer (  obs,IT_env);\
}\
	\
virtual void detach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Observer){\
m_obj->detach_tevent_data_observer (  obs,IT_env);\
}\
								\
	};						\


#define QUALS_TEvent_Data_Observed_E	\
virtual TEvent_Data_Observed_E::TEvent_Data_Observers* tevent_data_observer_list (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->tevent_data_observer_list(IT_env); \
}\
	\
virtual void attach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException){\
m_obj->attach_tevent_data_observer (  obs,IT_env);\
}\
	\
virtual void detach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Observer){\
m_obj->detach_tevent_data_observer (  obs,IT_env);\
}\




class TEvent_Data_Observed_EProxyFactoryClass : public virtual CORBA::ObjectFactoryClass {
public:
   TEvent_Data_Observed_EProxyFactoryClass (unsigned char IT_p=0)
		: CORBA::ProxyFactory (TEvent_Data_Observed_E_IR, IT_p) {}

    virtual void* New (char *IT_OR, CORBA::Environment&);

    virtual void* New (ObjectReferenceImpl *IT_OR, CORBA::Environment&);

    virtual void* New2 (); 

    virtual CORBA::Object* NewObject (char *IT_OR, CORBA::Environment&);

    virtual CORBA::Object* NewObject (ObjectReferenceImpl *IT_OR, CORBA::Environment&);

    virtual CORBA::Object* New2Object (); 

    virtual void* IT_castUp (void *IT_p, char* IT_s, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());

    virtual CORBA::PPTR* pptr (void *IT_p);

    virtual void baseInterfaces (_IDL_SEQUENCE_string&);


};

extern TEvent_Data_Observed_EProxyFactoryClass TEvent_Data_Observed_EProxyFactory;

#endif


#endif
