
#include "tevent_data_observed_e.hh"

TEvent_Data_Observed_E_mgr::TEvent_Data_Observed_E_mgr () 
{
    _ptr = TEvent_Data_Observed_E:: _nil ();
}

TEvent_Data_Observed_E_mgr::TEvent_Data_Observed_E_mgr (const TEvent_Data_Observed_E_mgr &IT_s) 
{
    _ptr = TEvent_Data_Observed_E:: _duplicate (IT_s._ptr);
}

TEvent_Data_Observed_E_mgr::TEvent_Data_Observed_E_mgr (TEvent_Data_Observed_E_var IT_s) 
{
    _ptr = TEvent_Data_Observed_E:: _duplicate (IT_s);
}

TEvent_Data_Observed_E_mgr::TEvent_Data_Observed_E_mgr (const TEvent_Data_Observed_E_SeqElem &IT_s) 
{
    _ptr = TEvent_Data_Observed_E:: _duplicate (IT_s);
}

TEvent_Data_Observed_E_mgr &TEvent_Data_Observed_E_mgr::operator= (TEvent_Data_Observed_E_ptr IT_p) {
    CORBA::release (_ptr);
    _ptr = IT_p;
    return (*this);
}

TEvent_Data_Observed_E_mgr &TEvent_Data_Observed_E_mgr::operator= (const TEvent_Data_Observed_E_mgr &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_E:: _duplicate(IT_s._ptr);
    return (*this);
}

TEvent_Data_Observed_E_mgr &TEvent_Data_Observed_E_mgr::operator= (TEvent_Data_Observed_E_var IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_E:: _duplicate(IT_s);
    return (*this);
}

TEvent_Data_Observed_E_mgr &TEvent_Data_Observed_E_mgr::operator= (const TEvent_Data_Observed_E_SeqElem &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_E:: _duplicate(IT_s);
    return (*this);
}

TEvent_Data_Observed_E_mgr::~TEvent_Data_Observed_E_mgr () {
    CORBA::release (_ptr);
}

TEvent_Data_Observed_E_ptr TEvent_Data_Observed_E_mgr:: operator-> () const {
    return _ptr;
}

TEvent_Data_Observed_E_mgr::operator ! () const {
    return ((CORBA::is_nil (_ptr)));
}

TEvent_Data_Observed_E_mgr::operator TEvent_Data_Observed_E_ptr& () { return (TEvent_Data_Observed_E_ptr &) (_ptr);}
TEvent_Data_Observed_E_mgr::operator const TEvent_Data_Observed_E_ptr& () const { return (TEvent_Data_Observed_E_ptr &) (_ptr);}

TEvent_Data_Observed_E_mgr::operator CORBA::Object_ptr () const {
    return _ptr;
}

TEvent_Data_Observed_E_ptr TEvent_Data_Observed_E_mgr:: in () const {
    return _ptr;
}

TEvent_Data_Observed_E_ptr& TEvent_Data_Observed_E_mgr:: inOut () {
    return _ptr;
}

TEvent_Data_Observed_E_ptr& TEvent_Data_Observed_E_mgr:: out () {
    return _ptr;
}

TEvent_Data_Observed_E_ptr TEvent_Data_Observed_E_mgr:: ret () const {
    return _ptr;
}

TEvent_Data_Observed_E_SeqElem::TEvent_Data_Observed_E_SeqElem (TEvent_Data_Observed_E_ptr* IT_p, unsigned char rel) {
    _ptr = IT_p;
    _release = rel;
}

TEvent_Data_Observed_E_SeqElem &TEvent_Data_Observed_E_SeqElem::operator= (TEvent_Data_Observed_E_ptr IT_p) {
    if (_ptr) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = IT_p;
    }
    return (*this);
}

TEvent_Data_Observed_E_SeqElem &TEvent_Data_Observed_E_SeqElem::operator= (const TEvent_Data_Observed_E_SeqElem &IT_s) {
    if (_ptr && IT_s._ptr) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Data_Observed_E:: _duplicate(*(IT_s._ptr));
    }
    return (*this);
}

TEvent_Data_Observed_E_SeqElem &TEvent_Data_Observed_E_SeqElem::operator= (const TEvent_Data_Observed_E_mgr &IT_s) {
    if (_ptr ) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Data_Observed_E:: _duplicate(IT_s._ptr);
    }
    return (*this);
}

TEvent_Data_Observed_E_SeqElem &TEvent_Data_Observed_E_SeqElem::operator= (TEvent_Data_Observed_E_var IT_s) {
    if (_ptr ) {
        if (_release)
            CORBA::release (*(_ptr));
        *(_ptr) = TEvent_Data_Observed_E:: _duplicate (IT_s);
    }
    return (*this);
}

TEvent_Data_Observed_E_SeqElem::operator ! () const {
    return ((CORBA::is_nil (*_ptr)));
}

TEvent_Data_Observed_E_SeqElem::operator const TEvent_Data_Observed_E_ptr& () const { return (TEvent_Data_Observed_E_ptr &) (*_ptr);}

TEvent_Data_Observed_E_SeqElem::operator CORBA::Object_ptr () const {
    return *_ptr;
}

TEvent_Data_Observed_E_ptr TEvent_Data_Observed_E_SeqElem:: in () const {
    return *_ptr;
}

TEvent_Data_Observed_E_ptr& TEvent_Data_Observed_E_SeqElem:: inOut () {
    return *_ptr;
}

TEvent_Data_Observed_E_ptr& TEvent_Data_Observed_E_SeqElem:: out () {
    return *_ptr;
}

TEvent_Data_Observed_E_ptr TEvent_Data_Observed_E_SeqElem:: ret () const {
    return *_ptr;
}

TEvent_Data_Observed_E_ptr TEvent_Data_Observed_E_SeqElem::operator->() const { return *_ptr;}

TEvent_Data_Observed_E::TEvent_Data_Observed_E (char *IT_OR) {
      m_pptr = new TEvent_Data_Observed_E_dispatch (IT_OR, this,(CORBA::Object*)this);
} 
TEvent_Data_Observed_E::TEvent_Data_Observed_E (ObjectReferenceImpl *IT_OR) {
      m_pptr = new TEvent_Data_Observed_E_dispatch (IT_OR, this,(CORBA::Object*)this);
} 

#ifndef TEvent_Data_Observed_EForwC
#define TEvent_Data_Observed_EForwC
CORBA::ObjectRef CALL_SPEC TEvent_Data_Observed_E_getBase(void *IT_p){
    return (TEvent_Data_Observed_E*) IT_p;}

void CALL_SPEC TEvent_Data_Observed_E_release (TEvent_Data_Observed_E_ptr IT_p, CORBA::Environment &IT_env) {
    CORBA::release(IT_p, IT_env);}

void CALL_SPEC TEvent_Data_Observed_E_release (TEvent_Data_Observed_E_ptr IT_p) {
    TEvent_Data_Observed_E_release (IT_p, CORBA::IT_chooseDefaultEnv ()); }

TEvent_Data_Observed_E_ptr CALL_SPEC TEvent_Data_Observed_E_nil (CORBA::Environment &) {
    return TEvent_Data_Observed_E:: _nil ();}

TEvent_Data_Observed_E_ptr CALL_SPEC TEvent_Data_Observed_E_nil () {
    return TEvent_Data_Observed_E_nil (CORBA::IT_chooseDefaultEnv ());}

TEvent_Data_Observed_E_ptr CALL_SPEC TEvent_Data_Observed_E_duplicate (TEvent_Data_Observed_E_ptr IT_p, CORBA::Environment &IT_env) {
    return (TEvent_Data_Observed_E::_duplicate(IT_p, IT_env)); }
TEvent_Data_Observed_E_ptr CALL_SPEC TEvent_Data_Observed_E_duplicate (TEvent_Data_Observed_E_ptr IT_p) {
    return TEvent_Data_Observed_E_duplicate (IT_p, CORBA::IT_chooseDefaultEnv ()); }
#endif

TEvent_Data_Observed_E_ptr CALL_SPEC TEvent_Data_Observed_E::_duplicate(TEvent_Data_Observed_E_ptr obj, CORBA::Environment& IT_pEnv) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
       if (!obj) {
          return (obj);
       }
       TEvent_Data_Observed_E_ptr IT_obj = obj->__duplicate (IT_env);
       return IT_obj;
}



TEvent_Data_Observed_E* CALL_SPEC TEvent_Data_Observed_E:: _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env) {
       return (TEvent_Data_Observed_E*)CORBA::Factory.New (IT_markerServer, IT_env, IT_c, host, 
		TEvent_Data_Observed_E_IMPL, TEvent_Data_Observed_E_IR);
}



TEvent_Data_Observed_E* CALL_SPEC TEvent_Data_Observed_E:: _bind (CORBA::Environment &IT_env) {
       return _bind (NULL,NULL,CORBA::Context(), IT_env); }


TEvent_Data_Observed_E* CALL_SPEC TEvent_Data_Observed_E:: _bind (const char* IT_markerServer, const char* host,
                CORBA::Environment &IT_env) {
       return _bind (IT_markerServer, host, CORBA::Context (), IT_env); }
TEvent_Data_Observed_E* CALL_SPEC TEvent_Data_Observed_E::_narrow (CORBA::Object* IT_obj, CORBA::Environment &IT_pEnv) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
        if (CORBA::is_nil (IT_obj)) {
                return TEvent_Data_Observed_E:: _nil();
        }

       TEvent_Data_Observed_E* IT_p = (TEvent_Data_Observed_E*)CORBA::Object::_castDown (IT_obj, TEvent_Data_Observed_E_IR, IT_env);
        IT_p = IT_p ? IT_p->__duplicate(IT_env) : NULL;
        if ((IT_env) &&(!strcmp(IT_env.exception()->id(), "CORBA::StExcep::BAD_PARAM")) && (((CORBA::BAD_PARAM*)IT_env.exception())-> minor() == NARROW_FAILED)) {
                IT_env.exception_free();
        }
        return IT_p;
   }

const void* TEvent_Data_Observed_E:: IT_impl = CORBA::IT_implTable.record (TEvent_Data_Observed_E_IMPL, "IDL:TEvent_Data_Observed_E:1.0");


#ifndef TEvent_Data_Observed_E__IDL_SEQUENCE_TEvent_Data_Observer_Ops
#define TEvent_Data_Observed_E__IDL_SEQUENCE_TEvent_Data_Observer_Ops

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: ~_IDL_SEQUENCE_TEvent_Data_Observer() {
    if (_buffer && _release) {
        {
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                TEvent_Data_Observer_release (_buffer[IT_i]);
            }
        }
        freebuf (_buffer);
    }
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: _IDL_SEQUENCE_TEvent_Data_Observer () {
    _release = 1;
    _length = 0;
    _maximum = 0;
    _buffer = NULL;
}


TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: _IDL_SEQUENCE_TEvent_Data_Observer (CORBA::ULong max, CORBA::ULong length, TEvent_Data_Observer_ptr* data, CORBA::Boolean release) {
    _release = release;
    _length = length;
    _maximum = max;
    _buffer = data;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: _IDL_SEQUENCE_TEvent_Data_Observer (const TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer &IT_s) {
    _length = IT_s._length;
    _release = 1;
    CORBA::ULong IT_maximum = _maximum = IT_s._maximum;
    if (IT_maximum) {
        _buffer = allocbuf (IT_maximum);
        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
            _buffer[IT_i] = TEvent_Data_Observer_duplicate (IT_s._buffer[IT_i]);
        }
    } else
        _buffer = NULL;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: _IDL_SEQUENCE_TEvent_Data_Observer (CORBA::ULong IT_size) {
    if (IT_size) {
        _buffer = allocbuf (IT_size);
    } else
        _buffer = NULL;
    _length = 0;
    _release = 1;
    _maximum = IT_size;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer& TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: operator= (const TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer &IT_s){
    if (this == &IT_s) return *this;
    if (_buffer && _release) {
        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
            TEvent_Data_Observer_release (_buffer[IT_i]);
        }
        for (CORBA::ULong IT_j = 0; IT_j < _length; IT_j++) {
            _buffer[IT_j] = TEvent_Data_Observer_nil();
        }
    }
    if (!_release || (IT_s._maximum > _maximum)) {
        if (_buffer && _release) {
            freebuf (_buffer);
        }
        _buffer = allocbuf (IT_s._maximum);
        _maximum = IT_s._maximum;
        _release = 1;
    }
    _length = IT_s._length;
    for (CORBA::ULong IT_j = 0; IT_j < _length; IT_j++) {
        _buffer[IT_j] = TEvent_Data_Observer_duplicate (IT_s._buffer[IT_j]);
    }
    return *this;
}

CORBA::ULong TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: maximum () const
{
    return _maximum;
}

CORBA::ULong TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: length () const
{
    return _length;
}

void TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: length (CORBA::ULong len) {
    if (len > _maximum) {
        TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer tempSeq (*this);
        if (_buffer && _release) {
            {
                for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                    TEvent_Data_Observer_release (_buffer[IT_i]);
                }
            }
            freebuf (_buffer);
        }
        _release = 1;
        _length = len;
        _maximum = len;
        _buffer = allocbuf(len);
        for (CORBA::ULong IT_i = 0; IT_i < tempSeq._length; IT_i++) {
            _buffer[IT_i] = TEvent_Data_Observer_duplicate (tempSeq._buffer[IT_i]);
        }
    } else if (len < _length) {
        if (_release) {
            for (CORBA::ULong IT_i = len; IT_i < _length; IT_i++) {
                TEvent_Data_Observer_release (_buffer[IT_i]);
            }
        }
        for (CORBA::ULong IT_j = len; IT_j < _length; IT_j++) {
            _buffer[IT_j] = TEvent_Data_Observer_nil();
        }
        _length = len;
    } else {
        _length = len;
    }
}

TEvent_Data_Observer_SeqElem TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: operator [] (CORBA::ULong IT_i)  {
    if (IT_i >= _length)
        ;
    TEvent_Data_Observer_SeqElem IT_seqElem (_buffer + IT_i, _release);
    return IT_seqElem;
}

const TEvent_Data_Observer_SeqElem TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: operator [] (CORBA::ULong IT_i) const  {
    if (IT_i >= _length)
        ;
    TEvent_Data_Observer_SeqElem IT_seqElem (_buffer + IT_i, _release);
    return IT_seqElem;
}

TEvent_Data_Observer_ptr* CALL_SPEC TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: allocbuf (CORBA::ULong _nelems)
{
    TEvent_Data_Observer_ptr *IT_Seq = new TEvent_Data_Observer_ptr[_nelems];
    for (CORBA::ULong IT_i = 0; IT_i < _nelems; IT_i++) {
        IT_Seq[IT_i] = TEvent_Data_Observer_nil();
    }
    return IT_Seq;
}

void CALL_SPEC TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: freebuf (TEvent_Data_Observer_ptr* _data)
{
    if (_data) delete [] _data;
}

void TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: assignbuf (CORBA::ULong max, CORBA::ULong length, TEvent_Data_Observer_ptr* data, CORBA::Boolean release) {
    if (_buffer && _release) {
        {
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                TEvent_Data_Observer_release (_buffer[IT_i]);
            }
        }
        freebuf (_buffer);
    }
    _release = release;
    _length = length;
    _maximum = max;
    _buffer = data;
}

void TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: decodeInOutOp (CORBA::Request &IT_r) {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            CORBA::ULong IT_max;
            CORBA::ULong IT_length;
            IT_r >> IT_length;
            IT_max = IT_length;
            if (!_release || (IT_max > _maximum)) {
                if (_buffer && _release) {
                    {
                        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                            TEvent_Data_Observer_release (_buffer[IT_i]);
                        }
                    }
                    freebuf (_buffer);
                }
                _buffer = allocbuf (IT_max);
                _maximum = IT_max;
                _release = 1;
            }
            if (IT_length > IT_max)
                IT_r.makeRuntimeException4 ();
            else {
                if (IT_length == _length) {
                    for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                        if (_release) {
                            TEvent_Data_Observer_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);
                    }
                } else if (IT_length < _length) {
                    for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                        if (_release) {
                            TEvent_Data_Observer_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);
                    }
                    for (CORBA::ULong IT_j = IT_length; IT_j < _length; IT_j++) {
                        TEvent_Data_Observer_release (_buffer[IT_j]);
                    }
                    for (CORBA::ULong IT_k = IT_length; IT_k < _length; IT_k++) {
                        _buffer[IT_k] = TEvent_Data_Observer_nil();
                    }
                } else {
                    for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                        if (_release) {
                            TEvent_Data_Observer_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);
                    }
                    for (CORBA::ULong IT_j = IT_length; IT_j < _length; IT_j++) {
                        _buffer[IT_j] = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);
                    }
                }
            }
            _length = IT_length;
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            CORBA::ULong IT_max;
            CORBA::ULong IT_length;
            IT_r >> IT_max;
            IT_r >> IT_length;
            unsigned char IT_codeSeqElems = IT_max ? 1 : 0;
            if (!_release || (IT_max > _maximum)) {
                if (_buffer && _release) {
                    {
                        for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                            TEvent_Data_Observer_release (_buffer[IT_i]);
                        }
                    }
                    freebuf (_buffer);
                }
                _buffer = allocbuf (IT_max);
                _maximum = IT_max;
                _release = 1;
            }
            if (IT_length > IT_max)
                IT_r.makeRuntimeException4 ();
            else {
                if (IT_length == _length) {
                    for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                        if (_release) {
                            TEvent_Data_Observer_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);
                    }
                } else if (IT_length < _length) {
                    for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                        if (_release) {
                            TEvent_Data_Observer_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);
                    }
                    for (CORBA::ULong IT_j = IT_length; IT_j < _length; IT_j++) {
                        TEvent_Data_Observer_release (_buffer[IT_j]);
                    }
                    for (CORBA::ULong IT_k = IT_length; IT_k < _length; IT_k++) {
                        _buffer[IT_k] = TEvent_Data_Observer_nil();
                    }
                } else {
                    for (CORBA::ULong IT_i = 0; IT_i < IT_length; IT_i++) {
                        if (_release) {
                            TEvent_Data_Observer_release (_buffer[IT_i]);
                        }
                        _buffer[IT_i] = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);
                    }
                    for (CORBA::ULong IT_j = IT_length; IT_j < _length; IT_j++) {
                        _buffer[IT_j] = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);
                    }
                }
            }
            _length = IT_length;
            break;
        }
    }
}

void TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: encodeOp (CORBA::Request &IT_r) const {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            IT_r << _length;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                IT_r.encodeForwardRef (TEvent_Data_Observer_getBase, (TEvent_Data_Observer_ptr) _buffer[IT_i]);
            }
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            IT_r << _maximum;
            IT_r << _length;
            unsigned char IT_codeSeqElems = _maximum ? 1 : 0;
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                IT_r.encodeForwardRef (TEvent_Data_Observer_getBase, (TEvent_Data_Observer_ptr) _buffer[IT_i]);
            }
            break;
        }
    }
}

void TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer:: decodeOp (CORBA::Request &IT_r) {
    switch (IT_r.targetProtocol()) {
        case CORBA::IT_INTEROPERABLE_OR_KIND:
        {
            IT_r >> _length;
            _maximum = _length;
            if (_maximum)
                _buffer = allocbuf (_maximum);
            else _buffer = 0;
            for (CORBA::ULong IT_j = 0; IT_j < _maximum; IT_j++) {
                _buffer[IT_j] = TEvent_Data_Observer_nil();
            }
            for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                _buffer[IT_i] = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);
            }
            break;
        }
        case CORBA::IT_ORBIX_OR_KIND:
        default:
        {
            IT_r >> _maximum;
            IT_r >> _length;
            unsigned char IT_codeSeqElems = _maximum ? 1 : 0;
            if (IT_codeSeqElems) {
                _buffer = allocbuf (_maximum);
                for (CORBA::ULong IT_j = 0; IT_j < _maximum; IT_j++) {
                    _buffer[IT_j] = TEvent_Data_Observer_nil();
                }
                for (CORBA::ULong IT_i = 0; IT_i < _length; IT_i++) {
                    _buffer[IT_i] = (TEvent_Data_Observer*) IT_r.decodeObjRef (TEvent_Data_Observer_IMPL);
                }
            }
            else
              _buffer = NULL;
            break;
        }
    }
}


unsigned char TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var ::copyHelper (const _IDL_SEQUENCE_TEvent_Data_Observer_var &IT_s) {
    if (!IT_s._ptr) {
        _ptr = IT_s._ptr;
    } else
    {
        _ptr = new _IDL_SEQUENCE_TEvent_Data_Observer;
        *(_ptr) =  *(IT_s._ptr);
    }
    return 1;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_ptr* TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var ::_newPtr () {
    return new TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_ptr;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var ::_IDL_SEQUENCE_TEvent_Data_Observer_var (const _IDL_SEQUENCE_TEvent_Data_Observer_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var ::_IDL_SEQUENCE_TEvent_Data_Observer_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = NULL;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var ::_IDL_SEQUENCE_TEvent_Data_Observer_var (_IDL_SEQUENCE_TEvent_Data_Observer_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var &TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var :: operator= (_IDL_SEQUENCE_TEvent_Data_Observer_ptr IT_p) {
    if (_ptr != IT_p) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = IT_p;
    return (*this);
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var &TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var :: operator= (const _IDL_SEQUENCE_TEvent_Data_Observer_var &IT_s) {
    if (_ptr != IT_s._ptr) {
        if (_ptr) {
                delete _ptr;
                _ptr = 0;
        }
    }
    _ptr = new _IDL_SEQUENCE_TEvent_Data_Observer;
    *(_ptr) =  *(IT_s._ptr);
    return (*this);
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var ::~_IDL_SEQUENCE_TEvent_Data_Observer_var () {
    if (_ptr) {
        delete _ptr;
        _ptr = 0;
    }
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_ptr TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var :: operator-> () const {
    return _ptr;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var::operator ! () const {
    return (_ptr ? 0 : 1);
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var::operator TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_ptr& () { return (TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_ptr &) (_ptr);}
TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var::operator const TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_cptr& () const { return (TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_cptr &) (_ptr);}
TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var:: operator TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer& () const { return (TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer&) (* _ptr);}

const TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var :: in () const {
    return *_ptr;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer& TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var :: inOut () {
    return *_ptr;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer*& TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var :: out () {
    return _ptr;
}

TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer* TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var :: ret () const {
    return _ptr;
}

TEvent_Data_Observer_SeqElem TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var:: operator[] (CORBA::ULong index) {
    return (*_ptr) [index];
}

const TEvent_Data_Observer_SeqElem TEvent_Data_Observed_E::_IDL_SEQUENCE_TEvent_Data_Observer_var:: operator[] (CORBA::ULong index) const {
    return (*_ptr) [index];
}


#endif

unsigned char TEvent_Data_Observed_E_var ::copyHelper (const TEvent_Data_Observed_E_var &IT_s) {
    {
        _ptr = TEvent_Data_Observed_E:: _duplicate (IT_s._ptr);
    }
    return 1;
}

unsigned char TEvent_Data_Observed_E_var ::copyHelper (const TEvent_Data_Observed_E_mgr &IT_s) {
    _ptr = TEvent_Data_Observed_E:: _duplicate (IT_s._ptr);
return 1;
}

unsigned char TEvent_Data_Observed_E_var ::copyHelper (const TEvent_Data_Observed_E_SeqElem &IT_s) {
    _ptr = TEvent_Data_Observed_E:: _duplicate (IT_s);
return 1;
}

TEvent_Data_Observed_E_ptr* TEvent_Data_Observed_E_var ::_newPtr () {
    return new TEvent_Data_Observed_E_ptr;
}

TEvent_Data_Observed_E_var ::TEvent_Data_Observed_E_var (const TEvent_Data_Observed_E_var &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Data_Observed_E_var ::TEvent_Data_Observed_E_var (const TEvent_Data_Observed_E_mgr &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Data_Observed_E_var ::TEvent_Data_Observed_E_var (const TEvent_Data_Observed_E_SeqElem &IT_s) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    (void) copyHelper (IT_s);
}

TEvent_Data_Observed_E_var ::TEvent_Data_Observed_E_var () 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = TEvent_Data_Observed_E:: _nil ();
}

TEvent_Data_Observed_E_var ::TEvent_Data_Observed_E_var (TEvent_Data_Observed_E_ptr IT_p) 
    :
    _indPtr(_newPtr()),
    _ptr(*_indPtr)
{
    _ptr = IT_p;
}

TEvent_Data_Observed_E_var &TEvent_Data_Observed_E_var :: operator= (TEvent_Data_Observed_E_ptr IT_p) {
    CORBA::release (_ptr);
    _ptr = IT_p;
    return (*this);
}

TEvent_Data_Observed_E_var &TEvent_Data_Observed_E_var :: operator= (const TEvent_Data_Observed_E_var &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_E:: _duplicate (IT_s._ptr);
    return (*this);
}

TEvent_Data_Observed_E_var &TEvent_Data_Observed_E_var :: operator= (const TEvent_Data_Observed_E_mgr &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_E:: _duplicate (IT_s._ptr);
    return (*this);
}

TEvent_Data_Observed_E_var &TEvent_Data_Observed_E_var :: operator= (const TEvent_Data_Observed_E_SeqElem &IT_s) {
    CORBA::release (_ptr);
    _ptr = TEvent_Data_Observed_E:: _duplicate (IT_s);
    return (*this);
}

TEvent_Data_Observed_E_var ::~TEvent_Data_Observed_E_var () {
    CORBA::release (_ptr);
    if ( _indPtr ) {
        delete _indPtr;
        _indPtr = 0;
    }
}

TEvent_Data_Observed_E_ptr TEvent_Data_Observed_E_var :: operator-> () const {
    return _ptr;
}

TEvent_Data_Observed_E_var::operator ! () const {
    return ((CORBA::is_nil (_ptr)));
}

TEvent_Data_Observed_E_var::operator TEvent_Data_Observed_E_ptr& () { return (TEvent_Data_Observed_E_ptr &) (_ptr);}
TEvent_Data_Observed_E_var::operator const TEvent_Data_Observed_E_cptr& () const { return (TEvent_Data_Observed_E_cptr &) (_ptr);}

TEvent_Data_Observed_E_var ::operator CORBA::Object_ptr () const {
    return _ptr;
}

TEvent_Data_Observed_E_ptr TEvent_Data_Observed_E_var :: in () const {
    return _ptr;
}

TEvent_Data_Observed_E_ptr& TEvent_Data_Observed_E_var :: inOut () {
    return _ptr;
}

TEvent_Data_Observed_E_ptr& TEvent_Data_Observed_E_var :: out () {
    return _ptr;
}

TEvent_Data_Observed_E_ptr TEvent_Data_Observed_E_var :: ret () const {
    return _ptr;
}

void* TEvent_Data_Observed_EProxyFactoryClass::New (char *IT_OR, CORBA::Environment&) {
        return  new class TEvent_Data_Observed_E(IT_OR);}

void* TEvent_Data_Observed_EProxyFactoryClass::New (ObjectReferenceImpl *IT_OR, CORBA::Environment&) {
        return  new class TEvent_Data_Observed_E(IT_OR);}

void* TEvent_Data_Observed_EProxyFactoryClass::New2 () {
        return  new class TEvent_Data_Observed_E((char*)0);}

CORBA::Object* TEvent_Data_Observed_EProxyFactoryClass::NewObject (char *IT_OR, CORBA::Environment& IT_env) {
        return (CORBA::Object*)((TEvent_Data_Observed_E*)New (IT_OR, IT_env));}

CORBA::Object* TEvent_Data_Observed_EProxyFactoryClass::NewObject (ObjectReferenceImpl *IT_OR, CORBA::Environment& IT_env) {
        return (CORBA::Object*)((TEvent_Data_Observed_E*)New (IT_OR, IT_env));}

CORBA::Object* TEvent_Data_Observed_EProxyFactoryClass::New2Object () {
        return (CORBA::Object*)((TEvent_Data_Observed_E*)New2 ());}

void* TEvent_Data_Observed_EProxyFactoryClass::IT_castUp (void *IT_p, char* IT_s, CORBA::Environment &IT_env) {
      void *IT_l;
      if (!CORBA::_interfaceCmp (IT_s,TEvent_Data_Observed_E_IR, IT_env))
         return IT_p;
      else if (IT_l=CORBA::ObjectFactoryClass::IT_castUp((CORBA::Object*)((class TEvent_Data_Observed_E*)IT_p),IT_s, IT_env))
         return IT_l;
      else return NULL;
    }


CORBA::PPTR* TEvent_Data_Observed_EProxyFactoryClass::pptr (void *IT_p) {
       return ((class TEvent_Data_Observed_E*)IT_p)->_pptr ();}

void TEvent_Data_Observed_EProxyFactoryClass::baseInterfaces (_IDL_SEQUENCE_string& seq) {
      add (seq, TEvent_Data_Observed_E_IR);
      CORBA::ObjectFactoryClass::baseInterfaces (seq);
}

TEvent_Data_Observed_EProxyFactoryClass TEvent_Data_Observed_EProxyFactory(1);

TEvent_Data_Observed_E::TEvent_Data_Observers* TEvent_Data_Observed_E::tevent_data_observer_list (CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
    return NULL;
    }

    CORBA::Request IT_r (this, "_get_tevent_data_observer_list",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        IT_r.invoke(CORBA::Flags(0), IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        TEvent_Data_Observed_E::TEvent_Data_Observers* tevent_data_observer_list;
        tevent_data_observer_list = new TEvent_Data_Observed_E::TEvent_Data_Observers;

        (*tevent_data_observer_list).decodeOp (IT_r);
        IT_r.checkEnv (IT_env);
        return tevent_data_observer_list;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
    return NULL;
}

void TEvent_Data_Observed_E:: attach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return ;
    }
    CORBA::Request IT_r (this, "attach_tevent_data_observer",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            IT_r.encodeForwardRef (TEvent_Data_Observer_getBase, (TEvent_Data_Observer_ptr) obs);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
}

void TEvent_Data_Observed_E:: detach_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_pEnv) throw (CORBA::SystemException, Domain_Repository::Unknown_Observer) {

    CORBA::EnvExcRaiser IT_raise;
    CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
    if (IT_env || m_isNull) {
        return ;
    }
    CORBA::Request IT_r (this, "detach_tevent_data_observer",IT_env,1,0);
    for (int IT_i1=0; IT_i1 < 2; IT_i1++) {
        if (!IT_r.isException (IT_env)) {

            IT_r.encodeForwardRef (TEvent_Data_Observer_getBase, (TEvent_Data_Observer_ptr) obs);
        }

        IT_r.invoke (CORBA::Flags(0),IT_env);
        CORBA::SystemException *IT_sy = CORBA::SystemException::_narrow(IT_env.exception()) ;
        if (IT_sy && IT_sy->minor() == 10601)
                IT_r.reset(IT_r.target(),  IT_r.operation(), IT_env);
        else
                break;
    }
    if (!IT_r.isException (IT_env)) {
        switch (IT_r.targetProtocol()) {
            case CORBA::IT_INTEROPERABLE_OR_KIND:
            {
                break;
            }
            case CORBA::IT_ORBIX_OR_KIND:
            default:
            {
                break;
            }
        }
    }
    else if (CORBA::UserException:: _narrow (IT_env.exception ())) { 
        const char* IT_str = IT_env.exception_id (); 
        if ((!strcmp (IT_str, Domain_Repository::ex_Unknown_Observer        )||!strcmp (IT_str, "Domain_Repository::Unknown_Observer"))) {
            CORBA::Exception *IT_ex =  new Domain_Repository::Unknown_Observer;
            ((Domain_Repository::Unknown_Observer*)IT_ex) -> decodeOp (IT_r);
            IT_env = IT_ex;
        }
    } else if (CORBA::SystemException:: _narrow (IT_env.exception ())) {
    }
    if (IT_r.exceptionKind () == CORBA::SYSTEM_EXCEPTION) {
        IT_r.checkEnv (IT_env);
    }
}





#ifndef TEvent_Data_Observed_E_dispatch_impl

unsigned char TEvent_Data_Observed_E_dispatch::dispatch (CORBA::Request &IT_r, 
    unsigned char, void *) {
      IT_r.makeRuntimeException1 ("TEvent_Data_Observed_E");
      return 0;
}
 
#endif

