
#ifndef tevent_rep_hh
#define tevent_rep_hh

#define CALL_SPEC 
#include <CORBA.h>

#include <string.h>


#include "domain_rep.hh"


#include "abng_core.hh"


#include "tevent_data_observed_e.hh"


#include "tevent.hh"


#include "tevent_data_observed_r.hh"


#ifndef _TEvent_Rep_defined
#define _TEvent_Rep_defined
class TEvent_Rep_dispatch : public virtual TEvent_Data_Observed_R_dispatch {
public:

      TEvent_Rep_dispatch (void *IT_p, CORBA::Object* IT_o, const char *IT_m, 
        CORBA::LoaderClass *IT_l, char *IT_i, void* IT_im)
       : PPTR (IT_p,IT_o,IT_m,IT_l,IT_i,IT_im) {}


   TEvent_Rep_dispatch (char *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : PPTR (IT_OR,IT_p,IT_o) {}


   TEvent_Rep_dispatch () {}

   TEvent_Rep_dispatch (ObjectReferenceImpl *IT_OR, void *IT_p, CORBA::Object *IT_o)
       : PPTR (IT_OR,IT_p,IT_o) {}


   TEvent_Rep_dispatch (void *IT_p, CORBA::Object *IT_o, const char *IT_m, 
        char *IT_i, CORBA::Object* IT_ob, void* IT_im)
       : PPTR (IT_p,IT_o,IT_m,IT_i,IT_ob,IT_im) {}


   virtual unsigned char dispatch (CORBA::Request &IT_r, 
        unsigned char IT_isTarget, void* IT_pp=NULL);


};

class TEvent_Rep;

#ifndef TEvent_RepPtr
#define TEvent_RepPtr
typedef TEvent_Rep* TEvent_Rep_ptr;
typedef TEvent_Rep* TEvent_RepRef;
#endif

#ifndef TEvent_Rep_ptrTypedefs
#define TEvent_Rep_ptrTypedefs
typedef const TEvent_Rep* TEvent_Rep_cptr;
#endif


#ifndef TEvent_RepForwH
#define TEvent_RepForwH
CORBA::ObjectRef CALL_SPEC TEvent_Rep_getBase (void *);
void CALL_SPEC TEvent_Rep_release (TEvent_Rep *, CORBA::Environment &IT_env);
void CALL_SPEC TEvent_Rep_release (TEvent_Rep_ptr);
TEvent_Rep* CALL_SPEC TEvent_Rep_duplicate (TEvent_Rep_ptr, CORBA::Environment &IT_env);
TEvent_Rep* CALL_SPEC TEvent_Rep_duplicate (TEvent_Rep_ptr );
TEvent_Rep_ptr CALL_SPEC TEvent_Rep_nil (CORBA::Environment &IT_env);
TEvent_Rep_ptr CALL_SPEC TEvent_Rep_nil ();
#endif
#ifndef TEvent_RepMgrH
#define TEvent_RepMgrH

class TEvent_Rep_var;

class TEvent_Rep_SeqElem;

#ifndef TEvent_Rep_ptrTypedefs
#define TEvent_Rep_ptrTypedefs
typedef const TEvent_Rep* TEvent_Rep_cptr;
#endif

class TEvent_Rep_mgr : public CORBA::_mgr
{
    public:

    TEvent_Rep_mgr ();
    TEvent_Rep_mgr (const TEvent_Rep_mgr &IT_s);
    TEvent_Rep_mgr (TEvent_Rep_var IT_s);
    TEvent_Rep_mgr (const TEvent_Rep_SeqElem &IT_s);
    TEvent_Rep_mgr &operator= (TEvent_Rep_ptr IT_p);
    TEvent_Rep_mgr &operator= (const TEvent_Rep_mgr &IT_s);
    TEvent_Rep_mgr &operator= (TEvent_Rep_var IT_s);
    TEvent_Rep_mgr &operator= (const TEvent_Rep_SeqElem &IT_s);
    ~TEvent_Rep_mgr ();
    TEvent_Rep_ptr operator-> () const;
    operator ! () const;
    operator TEvent_Rep_ptr& () ;
    operator const TEvent_Rep_ptr& () const;
    TEvent_Rep_ptr _ptr;

    operator CORBA::Object_ptr () const;
    TEvent_Rep_ptr in () const;
    TEvent_Rep_ptr& inOut ();
    TEvent_Rep_ptr& out ();
    TEvent_Rep_ptr ret () const;
};

#endif

#ifndef TEvent_RepSeqElemH
#define TEvent_RepSeqElemH

class TEvent_Rep_SeqElem : public CORBA::_SeqElem
{
    public:

    TEvent_Rep_SeqElem (TEvent_Rep_ptr* IT_p, unsigned char rel);
    TEvent_Rep_SeqElem &operator= (TEvent_Rep_ptr IT_p);
    TEvent_Rep_SeqElem &operator= (const TEvent_Rep_SeqElem &IT_s);
    TEvent_Rep_SeqElem &operator= (const TEvent_Rep_mgr &IT_s);
    TEvent_Rep_SeqElem &operator= (TEvent_Rep_var IT_s);
    operator ! () const;
    operator const TEvent_Rep_ptr& () const;
    operator CORBA::Object_ptr () const;
    TEvent_Rep_ptr in () const;
    TEvent_Rep_ptr& inOut ();
    TEvent_Rep_ptr& out ();
    TEvent_Rep_ptr ret () const;
    TEvent_Rep_ptr operator->() const;

    protected:
    TEvent_Rep_ptr *_ptr;
    unsigned char _release;
};

#endif

#define TEvent_Rep_IMPL "TEvent_Rep"


class TEvent_Rep;

typedef TEvent_Rep TEvent_RepProxy;
#define TEvent_Rep_IR "TEvent_Rep"
#define TEvent_Rep_IMPL "TEvent_Rep"

#ifndef TEvent_RepPtr
#define TEvent_RepPtr
typedef TEvent_Rep* TEvent_Rep_ptr;
typedef TEvent_Rep* TEvent_RepRef;
#endif

#ifndef TEvent_Rep_ptrTypedefs
#define TEvent_Rep_ptrTypedefs
typedef const TEvent_Rep* TEvent_Rep_cptr;
#endif

class TEvent_Rep: public virtual TEvent_Data_Observed_R {
public:
        TEvent_Rep (char *IT_OR);
    TEvent_Rep (ObjectReferenceImpl *IT_OR);
    TEvent_Rep () : CORBA::Object  (1) {}
protected:
    TEvent_Rep_ptr __duplicate(
            CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) {
       CORBA::Object::__duplicate (IT_env);
       return this;
    }
public:
    static TEvent_Rep_ptr CALL_SPEC _duplicate(
            TEvent_Rep_ptr, 
            CORBA::Environment &IT_pEnv=CORBA::IT_chooseDefaultEnv ());
public:
   static TEvent_Rep* CALL_SPEC _bind (const char* IT_markerServer, const char* host,
		const CORBA::Context &IT_c, 
		CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
   static TEvent_Rep* CALL_SPEC _bind (CORBA::Environment &IT_env);
   static TEvent_Rep* CALL_SPEC _bind (const char* IT_markerServer=NULL, const char* host=NULL,
                 CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
    static TEvent_Rep* CALL_SPEC _narrow (CORBA::Object* , CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());
private:
    static const void* IT_impl;
public:
    static TEvent_Rep_ptr CALL_SPEC  _nil (CORBA::Environment &IT_pEnv=CORBA::IT_chooseDefaultEnv ()) {
        CORBA::EnvExcRaiser IT_raise;
        CORBA::Environment &IT_env = IT_raise.registerEnv (&IT_pEnv);
        return (TEvent_Rep_ptr) CORBA::OBJECT_NIL;}
        virtual TEvents* find (const TEvent::Pattern& data_record_pattern, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable);
        virtual TEvent::Value_Descriptions* find_values (const TEvent::Pattern& data_record_pattern, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable);
        virtual TEvent::Query_Results* complex_query (const TEvent::Entity_Set& es, const Domain_Repository::Query_Options& qo, TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ()) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable);
};

#ifndef TEvent_RepVarH
#define TEvent_RepVarH

#ifndef TEvent_Rep_ptrTypedefs
#define TEvent_Rep_ptrTypedefs
typedef const TEvent_Rep* TEvent_Rep_cptr;
#endif

class TEvent_Rep_var : public CORBA::_var
{
    private:

    unsigned char copyHelper (const TEvent_Rep_var &IT_s);
    unsigned char copyHelper (const TEvent_Rep_mgr &IT_s);
    unsigned char copyHelper (const TEvent_Rep_SeqElem &IT_s);

    public:

    TEvent_Rep_var (const TEvent_Rep_var &IT_s);
    TEvent_Rep_var (const TEvent_Rep_mgr &IT_s);
    TEvent_Rep_var (const TEvent_Rep_SeqElem &IT_s);
    TEvent_Rep_var ();
    TEvent_Rep_var (TEvent_Rep_ptr IT_p);
    TEvent_Rep_var &operator= (TEvent_Rep_ptr IT_p);
    TEvent_Rep_var &operator= (const TEvent_Rep_var &IT_s);
    TEvent_Rep_var &operator= (const TEvent_Rep_mgr &IT_s);
    TEvent_Rep_var &operator= (const TEvent_Rep_SeqElem &IT_s);
    ~TEvent_Rep_var ();
    TEvent_Rep_ptr operator-> () const;
    operator ! () const;
    operator TEvent_Rep_ptr& () ;
    operator const TEvent_Rep_cptr& () const;

    operator CORBA::Object_ptr () const;
    TEvent_Rep_ptr in () const;
    TEvent_Rep_ptr& inOut ();
    TEvent_Rep_ptr& out ();
    TEvent_Rep_ptr ret () const;
    protected:
    TEvent_Rep_ptr* _indPtr;
    TEvent_Rep_ptr& _ptr;
    private:
    static TEvent_Rep_ptr* _newPtr ();
    TEvent_Rep_var &operator= (const CORBA::_var &IT_s);
    TEvent_Rep_var (const CORBA::_var &IT_s);
};

#endif



#define TIE_TEvent_Rep(X) TEvent_Rep##X

#define DEF_TIE_TEvent_Rep(X) \
	class TEvent_Rep##X : public virtual TEvent_Rep {		\
	  X* m_obj;						\
	public:							\
								\
								\
	   TEvent_Rep##X  (X *objp, const char* m="", CORBA::LoaderClass *l=0)\
		: TEvent_Rep(), m_obj(objp) {	\
		m_pptr = new TEvent_Rep_dispatch		\
			(( TEvent_Rep*)this,(CORBA::Object*)this,m,l,TEvent_Rep_IR,m_obj);	\
	   }								\
	   TEvent_Rep##X  (CORBA::Object *IT_p, const char* IT_m="", void *IT_q=0)\
		: TEvent_Rep() {	\
		m_pptr = new TEvent_Rep_dispatch		\
			(( TEvent_Rep*)this,(CORBA::Object*)this,IT_m,TEvent_Rep_IR,IT_p,IT_q);	\
		m_obj = (X*)(m_pptr->getImplObj ());			\
	   }								\
								\
	   virtual ~TEvent_Rep##X  () {				\
		if (_okToDeleteImpl ()) delete m_obj; }					\
	   virtual void* _deref () {					\
		return m_obj; }					\
								\
virtual TEvent_Data_Observed_R::Observer_Entries* tevent_data_observer_list (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->tevent_data_observer_list(IT_env); \
}\
	\
virtual TEvent_Data_Observed_E::TEvent_Data_Observers* add_tevent_data_observer_list (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->add_tevent_data_observer_list(IT_env); \
}\
	\
virtual void attach_tevent_data_observer (TEvent_Data_Observer_ptr obs, const Domain_Repository::Repository_Item_Ids& observed_id_list, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Repository_Item_Ids){\
m_obj->attach_tevent_data_observer (  obs,  observed_id_list,IT_env);\
}\
	\
virtual void detach_tevent_data_observer (TEvent_Data_Observer_ptr obs, const Domain_Repository::Repository_Item_Ids& observed_id_list, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Repository_Item_Ids, Domain_Repository::Unknown_Observer, Domain_Repository::Unmatched_Observer_Item_Ids){\
m_obj->detach_tevent_data_observer (  obs,  observed_id_list,IT_env);\
}\
	\
virtual void attach_add_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException){\
m_obj->attach_add_tevent_data_observer (  obs,IT_env);\
}\
	\
virtual void detach_add_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Observer){\
m_obj->detach_add_tevent_data_observer (  obs,IT_env);\
}\
virtual TEvents* find (const TEvent::Pattern& data_record_pattern, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable){\
return m_obj->find (  data_record_pattern,IT_env);\
}\
	\
virtual TEvent::Value_Descriptions* find_values (const TEvent::Pattern& data_record_pattern, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable){\
return m_obj->find_values (  data_record_pattern,IT_env);\
}\
	\
virtual TEvent::Query_Results* complex_query (const TEvent::Entity_Set& es, const Domain_Repository::Query_Options& qo, TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable){\
return m_obj->complex_query (  es,  qo,  obs,IT_env);\
}\
								\
	};						\


#define QUALS_TEvent_Rep	\
virtual TEvent_Data_Observed_R::Observer_Entries* tevent_data_observer_list (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->tevent_data_observer_list(IT_env); \
}\
	\
virtual TEvent_Data_Observed_E::TEvent_Data_Observers* add_tevent_data_observer_list (CORBA::Environment &IT_env) throw (CORBA::SystemException)  {\
return m_obj->add_tevent_data_observer_list(IT_env); \
}\
	\
virtual void attach_tevent_data_observer (TEvent_Data_Observer_ptr obs, const Domain_Repository::Repository_Item_Ids& observed_id_list, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Repository_Item_Ids){\
m_obj->attach_tevent_data_observer (  obs,  observed_id_list,IT_env);\
}\
	\
virtual void detach_tevent_data_observer (TEvent_Data_Observer_ptr obs, const Domain_Repository::Repository_Item_Ids& observed_id_list, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Repository_Item_Ids, Domain_Repository::Unknown_Observer, Domain_Repository::Unmatched_Observer_Item_Ids){\
m_obj->detach_tevent_data_observer (  obs,  observed_id_list,IT_env);\
}\
	\
virtual void attach_add_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException){\
m_obj->attach_add_tevent_data_observer (  obs,IT_env);\
}\
	\
virtual void detach_add_tevent_data_observer (TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Unknown_Observer){\
m_obj->detach_add_tevent_data_observer (  obs,IT_env);\
}\
virtual TEvents* find (const TEvent::Pattern& data_record_pattern, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable){\
return m_obj->find (  data_record_pattern,IT_env);\
}\
	\
virtual TEvent::Value_Descriptions* find_values (const TEvent::Pattern& data_record_pattern, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable){\
return m_obj->find_values (  data_record_pattern,IT_env);\
}\
	\
virtual TEvent::Query_Results* complex_query (const TEvent::Entity_Set& es, const Domain_Repository::Query_Options& qo, TEvent_Data_Observer_ptr obs, CORBA::Environment &IT_env) throw (CORBA::SystemException, Domain_Repository::Search_Not_Implemented, Domain_Repository::Destination_Unreachable){\
return m_obj->complex_query (  es,  qo,  obs,IT_env);\
}\




class TEvent_RepProxyFactoryClass : public virtual TEvent_Data_Observed_RProxyFactoryClass {
public:
   TEvent_RepProxyFactoryClass (unsigned char IT_p=0)
		: CORBA::ProxyFactory (TEvent_Rep_IR, IT_p) {}

    virtual void* New (char *IT_OR, CORBA::Environment&);

    virtual void* New (ObjectReferenceImpl *IT_OR, CORBA::Environment&);

    virtual void* New2 (); 

    virtual CORBA::Object* NewObject (char *IT_OR, CORBA::Environment&);

    virtual CORBA::Object* NewObject (ObjectReferenceImpl *IT_OR, CORBA::Environment&);

    virtual CORBA::Object* New2Object (); 

    virtual void* IT_castUp (void *IT_p, char* IT_s, CORBA::Environment &IT_env=CORBA::IT_chooseDefaultEnv ());

    virtual CORBA::PPTR* pptr (void *IT_p);

    virtual void baseInterfaces (_IDL_SEQUENCE_string&);


};

extern TEvent_RepProxyFactoryClass TEvent_RepProxyFactory;

#endif


#endif
