package jabba;

import com.sun.java.swing.JTable;
import com.sun.java.swing.table.TableColumn;
import com.sun.java.swing.table.TableColumnModel;

import java.awt.Component;

/**
 * Helps performing some interface-oriented operations.
 */
class ViewerTabHelper {
  public static void initColumnSizes( JTable table, AbstractJabbaTableDataModel model ) {
    TableColumn column=null;
    Component component=null;
    int hWidth=0,cWidth=0;
    TableColumnModel clModel = table.getColumnModel();

    for( int i=0; i<model.getColumnCount(); i++ ) {
      column = clModel.getColumn(i);
      component = column.getHeaderRenderer().
	getTableCellRendererComponent( table,column.getHeaderValue(),
				       false,false,0,0 );
      hWidth = component.getPreferredSize().width;
      
      component = table.getDefaultRenderer( model.getColumnClass(i) ).
	getTableCellRendererComponent( table,model.getLongValue(i),
				       false,false,0,i );
      cWidth = component.getPreferredSize().width;

      column.setMinWidth(Math.max(hWidth,cWidth));
    }
  }
  
}
