//
//  File:         meta_equipment_server.cc
//  Author:       Andrzej Uszok (uszok@ics.agh.edu.pl)
//  Date Created: 20.04.98
//
// General Description:
//   Implementation file of the Meta_Equipment_Rep_Server class
//

#include "meta_equipment_rep_server.h"

void Meta_Equipment_Rep_Server::create_objects() 
{
  my_rep_i = new Meta_Equipment_Rep_I(file_name);
  my_rep_i->init(cold_start);
}

void Meta_Equipment_Rep_Server::delete_objects() 
{
  delete my_rep_i;
}
