// $Id: msp_server.h,v 1.1.1.1 1998/06/18 13:37:37 mencnar Exp $
//
// $Source: /home/iris/grant/abng/CVS/sources/servers/sighting_processors/msp_server.h,v $
//
// $Log: msp_server.h,v $
// Revision 1.1.1.1  1998/06/18 13:37:37  mencnar
//
// Revision 1.1  1998/03/06 13:47:50  jasz
// Initial revision
//
//
// File:          msp_server_i.h
// Author:        Jakub Szymaszek (jasz@ics.agh.edu.pl)
// Date Created:  26.01.98
//
// General Description:
//  Declaration of the MSP server class.

#ifndef __MSP_SERVER_I_H__
#define __MSP_SERVER_I_H__

#include <signal.h>
#include "msp_i.h"
#include "msp_server.h"
#include "basic_server.h"

class MSP_Server : public Basic_Server {

public:

  virtual ~MSP_Server() {}

  virtual void init(int argc, char **argv);
  virtual void final();
  static MSP_Server *get_instance();

protected:

  MSP_Server() : Basic_Server() {}
  static void signal_handler(int sig);
  virtual void print_info();
  char *prog_name;

  static MSP_Server *my_instance;
  MSP_I *my_msp;
};

#endif /* __MSP_SERVER_I_H__ */
