#ifndef __BADGE_REP_CLIENT_H__
#define __BADGE_REP_CLIENT_H__ 1

#include <stream.h>

#include "abng_core_types.h"
#include "bootstrap_n.hh"
#include "rep_client.h"


class Badge_Rep_Client : public Rep_Client<Badge_Types> {

public:

  Badge_Rep_Client() : Rep_Client<Badge_Types>(
                      Bootstrap::SRV_Badge_Repository,
                      Bootstrap::SRV_Badge_Repository) {
    
    badge_holder_rep = new Basic_Client<Badge_Holder_Types>(
			      Bootstrap::SRV_Badge_Holder_Repository
			      );
    
  }

  virtual ~Badge_Rep_Client() {}

  virtual ABng_Core_System::Badge::Description
        init_data(char* data);
 
protected:
  Basic_Client<Badge_Holder_Types>* badge_holder_rep;
};

#endif __BADGE_REP_CLIENT_H__





